/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_rd_cp_api_fromjson_h
#define included_rd_cp_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_ip6_nd_address_autoconfig_t *vl_api_ip6_nd_address_autoconfig_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6_nd_address_autoconfig_t);
    vl_api_ip6_nd_address_autoconfig_t *a = malloc(l);
    // processing ip6_nd_address_autoconfig: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing ip6_nd_address_autoconfig: bool enable
    item = cJSON_GetObjectItem(o, "enable");
    if (!item) return 0;
    // start field enable
    vl_api_bool_fromjson(item, &a->enable);
    // end field enable

    // processing ip6_nd_address_autoconfig: bool install_default_routes
    item = cJSON_GetObjectItem(o, "install_default_routes");
    if (!item) return 0;
    // start field install_default_routes
    vl_api_bool_fromjson(item, &a->install_default_routes);
    // end field install_default_routes


    *len = l;
    return a;
}
static inline vl_api_ip6_nd_address_autoconfig_reply_t *vl_api_ip6_nd_address_autoconfig_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_ip6_nd_address_autoconfig_reply_t);
    vl_api_ip6_nd_address_autoconfig_reply_t *a = malloc(l);
    // processing ip6_nd_address_autoconfig_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
