/* Imported API files */
#ifndef included_policer_types_api_fromjson_h
#define included_policer_types_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_sse2_qos_rate_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_sse2_qos_rate_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SSE2_QOS_RATE_API_KBPS") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SSE2_QOS_RATE_API_PPS") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SSE2_QOS_RATE_API_INVALID") == 0) {*a = 2; return mp;}
   return 0;
}
static inline void *vl_api_sse2_qos_round_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_sse2_qos_round_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SSE2_QOS_ROUND_API_TO_CLOSEST") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SSE2_QOS_ROUND_API_TO_UP") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SSE2_QOS_ROUND_API_TO_DOWN") == 0) {*a = 2; return mp;}
    if (strcmp(p, "SSE2_QOS_ROUND_API_INVALID") == 0) {*a = 3; return mp;}
   return 0;
}
static inline void *vl_api_sse2_qos_policer_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_sse2_qos_policer_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SSE2_QOS_POLICER_TYPE_API_1R2C") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SSE2_QOS_POLICER_TYPE_API_1R3C_RFC_2697") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SSE2_QOS_POLICER_TYPE_API_2R3C_RFC_2698") == 0) {*a = 2; return mp;}
    if (strcmp(p, "SSE2_QOS_POLICER_TYPE_API_2R3C_RFC_4115") == 0) {*a = 3; return mp;}
    if (strcmp(p, "SSE2_QOS_POLICER_TYPE_API_2R3C_RFC_MEF5CF1") == 0) {*a = 4; return mp;}
    if (strcmp(p, "SSE2_QOS_POLICER_TYPE_API_MAX") == 0) {*a = 5; return mp;}
   return 0;
}
static inline void *vl_api_sse2_qos_action_type_t_fromjson (void *mp, int *len, cJSON *o, vl_api_sse2_qos_action_type_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SSE2_QOS_ACTION_API_DROP") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SSE2_QOS_ACTION_API_TRANSMIT") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SSE2_QOS_ACTION_API_MARK_AND_TRANSMIT") == 0) {*a = 2; return mp;}
   return 0;
}
static inline void *vl_api_sse2_qos_action_t_fromjson (void *mp, int *len, cJSON *o, vl_api_sse2_qos_action_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    item = cJSON_GetObjectItem(o, "type");
    if (!item) return 0;
    // start field type
    mp = vl_api_sse2_qos_action_type_t_fromjson(mp, len, item, &a->type);
    if (!mp) return 0;
    // end field type
    item = cJSON_GetObjectItem(o, "dscp");
    if (!item) return 0;
    // start field dscp
    vl_api_u8_fromjson(item, &a->dscp);
    // end field dscp
    return mp;
}
#endif
