/* Imported API files */
#ifndef included_tunnel_types_api_tojson_h
#define included_tunnel_types_api_tojson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline cJSON *vl_api_tunnel_encap_decap_flags_t_tojson (vl_api_tunnel_encap_decap_flags_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_NONE");
    case 1:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_COPY_DF");
    case 2:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_SET_DF");
    case 4:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_COPY_DSCP");
    case 8:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_COPY_ECN");
    case 16:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_DECAP_COPY_ECN");
    case 32:
        return cJSON_CreateString("TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_INNER_HASH");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_tunnel_mode_t_tojson (vl_api_tunnel_mode_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("TUNNEL_API_MODE_P2P");
    case 1:
        return cJSON_CreateString("TUNNEL_API_MODE_MP");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
#endif
