/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_gso_api_fromjson_h
#define included_gso_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline vl_api_feature_gso_enable_disable_t *vl_api_feature_gso_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_feature_gso_enable_disable_t);
    vl_api_feature_gso_enable_disable_t *a = malloc(l);
    // processing feature_gso_enable_disable: vl_api_interface_index_t sw_if_index
    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) return 0;
    // start field sw_if_index
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index);
    if (!a) return 0;
    // end field sw_if_index

    // processing feature_gso_enable_disable: bool enable_disable
    item = cJSON_GetObjectItem(o, "enable_disable");
    if (!item) return 0;
    // start field enable_disable
    vl_api_bool_fromjson(item, &a->enable_disable);
    // end field enable_disable


    *len = l;
    return a;
}
static inline vl_api_feature_gso_enable_disable_reply_t *vl_api_feature_gso_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_feature_gso_enable_disable_reply_t);
    vl_api_feature_gso_enable_disable_reply_t *a = malloc(l);
    // processing feature_gso_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
#endif
