/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_span_api_fromjson_h
#define included_span_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_span_state_t_fromjson (void *mp, int *len, cJSON *o, vl_api_span_state_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "SPAN_STATE_API_DISABLED") == 0) {*a = 0; return mp;}
    if (strcmp(p, "SPAN_STATE_API_RX") == 0) {*a = 1; return mp;}
    if (strcmp(p, "SPAN_STATE_API_TX") == 0) {*a = 2; return mp;}
    if (strcmp(p, "SPAN_STATE_API_RX_TX") == 0) {*a = 3; return mp;}
   return 0;
}
static inline vl_api_sw_interface_span_enable_disable_t *vl_api_sw_interface_span_enable_disable_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_span_enable_disable_t);
    vl_api_sw_interface_span_enable_disable_t *a = malloc(l);
    // processing sw_interface_span_enable_disable: vl_api_interface_index_t sw_if_index_from
    item = cJSON_GetObjectItem(o, "sw_if_index_from");
    if (!item) return 0;
    // start field sw_if_index_from
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index_from);
    if (!a) return 0;
    // end field sw_if_index_from

    // processing sw_interface_span_enable_disable: vl_api_interface_index_t sw_if_index_to
    item = cJSON_GetObjectItem(o, "sw_if_index_to");
    if (!item) return 0;
    // start field sw_if_index_to
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index_to);
    if (!a) return 0;
    // end field sw_if_index_to

    // processing sw_interface_span_enable_disable: vl_api_span_state_t state
    item = cJSON_GetObjectItem(o, "state");
    if (!item) return 0;
    // start field state
    a = vl_api_span_state_t_fromjson(a, &l, item, &a->state);
    if (!a) return 0;
    // end field state

    // processing sw_interface_span_enable_disable: bool is_l2
    item = cJSON_GetObjectItem(o, "is_l2");
    if (!item) return 0;
    // start field is_l2
    vl_api_bool_fromjson(item, &a->is_l2);
    // end field is_l2


    *len = l;
    return a;
}
static inline vl_api_sw_interface_span_enable_disable_reply_t *vl_api_sw_interface_span_enable_disable_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_span_enable_disable_reply_t);
    vl_api_sw_interface_span_enable_disable_reply_t *a = malloc(l);
    // processing sw_interface_span_enable_disable_reply: i32 retval
    item = cJSON_GetObjectItem(o, "retval");
    if (!item) return 0;
    // start field retval
    vl_api_i32_fromjson(item, &a->retval);
    // end field retval


    *len = l;
    return a;
}
static inline vl_api_sw_interface_span_dump_t *vl_api_sw_interface_span_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_span_dump_t);
    vl_api_sw_interface_span_dump_t *a = malloc(l);
    // processing sw_interface_span_dump: bool is_l2
    item = cJSON_GetObjectItem(o, "is_l2");
    if (!item) return 0;
    // start field is_l2
    vl_api_bool_fromjson(item, &a->is_l2);
    // end field is_l2


    *len = l;
    return a;
}
static inline vl_api_sw_interface_span_details_t *vl_api_sw_interface_span_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_span_details_t);
    vl_api_sw_interface_span_details_t *a = malloc(l);
    // processing sw_interface_span_details: vl_api_interface_index_t sw_if_index_from
    item = cJSON_GetObjectItem(o, "sw_if_index_from");
    if (!item) return 0;
    // start field sw_if_index_from
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index_from);
    if (!a) return 0;
    // end field sw_if_index_from

    // processing sw_interface_span_details: vl_api_interface_index_t sw_if_index_to
    item = cJSON_GetObjectItem(o, "sw_if_index_to");
    if (!item) return 0;
    // start field sw_if_index_to
    a = vl_api_interface_index_t_fromjson(a, &l, item, &a->sw_if_index_to);
    if (!a) return 0;
    // end field sw_if_index_to

    // processing sw_interface_span_details: vl_api_span_state_t state
    item = cJSON_GetObjectItem(o, "state");
    if (!item) return 0;
    // start field state
    a = vl_api_span_state_t_fromjson(a, &l, item, &a->state);
    if (!a) return 0;
    // end field state

    // processing sw_interface_span_details: bool is_l2
    item = cJSON_GetObjectItem(o, "is_l2");
    if (!item) return 0;
    // start field is_l2
    vl_api_bool_fromjson(item, &a->is_l2);
    // end field is_l2


    *len = l;
    return a;
}
#endif
