/* Imported API files */
#ifndef included_tunnel_types_api_fromjson_h
#define included_tunnel_types_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline void *vl_api_tunnel_encap_decap_flags_t_fromjson (void *mp, int *len, cJSON *o, vl_api_tunnel_encap_decap_flags_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_NONE") == 0) {*a = 0; return mp;}
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_COPY_DF") == 0) {*a = 1; return mp;}
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_SET_DF") == 0) {*a = 2; return mp;}
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_COPY_DSCP") == 0) {*a = 4; return mp;}
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_COPY_ECN") == 0) {*a = 8; return mp;}
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_DECAP_COPY_ECN") == 0) {*a = 16; return mp;}
    if (strcmp(p, "TUNNEL_API_ENCAP_DECAP_FLAG_ENCAP_INNER_HASH") == 0) {*a = 32; return mp;}
   return 0;
}
static inline void *vl_api_tunnel_mode_t_fromjson (void *mp, int *len, cJSON *o, vl_api_tunnel_mode_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "TUNNEL_API_MODE_P2P") == 0) {*a = 0; return mp;}
    if (strcmp(p, "TUNNEL_API_MODE_MP") == 0) {*a = 1; return mp;}
   return 0;
}
#endif
